﻿using System;
using System.Web.Mvc;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Mvc;
using ThinkGeo.MapSuite.Shapes;

namespace MarkerEventDemo.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home 
        public ActionResult Index()
        {
            return View();
        }

        [MapActionFilter]
        public void AddMarker(Map map, GeoCollection<object> args)
        {
            PointShape pointShape = new PointShape(string.Format("POINT ({0} {1})", args[0], args[1]));
            SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)map.CustomOverlays["MarkerOverlay"];
            markerOverlay.Markers.Clear();
            markerOverlay.Markers.Add(new Marker(pointShape));
        }

        [MapActionFilter]
        public void ClickOnMarker(Map map, GeoCollection<object> args)
        {
            SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)map.CustomOverlays["MarkerOverlay"];
            CloudPopup tempPopup = (CloudPopup)map.Popups[0];
            string popupContentHtml = string.Empty;
            if (Session["ShowPopup"] == null)
            {
                PointShape pointShape = markerOverlay.Markers[0].Position;
                string content = String.Format("<span class='popup'>latitude:{0}</br>longitude:{1}</span>", pointShape.X, pointShape.Y);
                popupContentHtml = content;
                tempPopup.Position = pointShape;
                tempPopup.IsVisible = true;
                Session["ShowPopup"] = tempPopup.IsVisible;
            }
            else
            {
                tempPopup.IsVisible = false;
                Session["ShowPopup"] = null;
            }

            tempPopup.ContentHtml = popupContentHtml;
        }
    }
}